
	.export		_nmi_main

	.import		_ret_ppu_ctrl

	;---------------
	;ϐ
	.import		_ppu_ctrl
;
	.import		_ppu_sprite_buff
	.importzp	_ppu_sprite_flag

;	.importzp	_ppu_scroll_x
;	.importzp	_ppu_scroll_y
	.importzp	ptx_Scroll
	.importzp	ptb_Scroll

	.importzp	_ppu_stream_flag
	.importzp	_ppu_stream_flag_a
	.importzp	_ppu_stream_addr
	.importzp	_ppu_stream_addr_a
	.importzp	_ppu_vram_addr
	.importzp	_ppu_vram_addr_a
	.importzp	_nmi_count
	.importzp	pad

	.include	"gekioko.inc"

;===============================================================
;			nmi_main(void);
;---------------------------------------------------------------
;	Summary :		NMI main Routine
;	Arguments :		None
;	Return :		None
;	Modifies :		None
;	Useage :		Please write this address to interrupt vector
;---------------------------------------------------------------
;	st
;	ENMI荞݂́APPU֘Ȃɂ
;	@PPUւ̃ANZX́AAҒɂłȂ߁B
;	EL[̓ǂݍ݂ANMI荞݂ōsB
;	@L[ǂݍݒɉhCo[荞ނƁAL[ǂݍ݂Ɏs邽߁B
;===============================================================
.code
.proc	_nmi_main

;---------------------------------------
;register push
;---------------------------------------
	pha
	tya
	pha
	txa
	pha

;---------------------------------------
; Write screen data to VRAM (PPU)
;---------------------------------------

	;---------------
	;PPU ]
	;c or  ֈꊇœ]܂B
	;AAvbl Ԃɓ]łTCYB
PPU_Steram:
	lda	_ppu_stream_flag
	beq	PPU_Steram_a

	asl	a		;
	adc	#0		;Cy <- A bit 7
	lsr	a		;A  <- A AND 0x7F
	tax			;X  <- A
	lda	_ppu_ctrl
	bcc	@V
	ora	#%00000100
	bne	@Set
@V:	and	#%11111011
@Set:	sta	PPU_CTRL1
	ldy	#$0
	lda	_ppu_vram_addr + 1
	sta	PPU_VRAM_ADDR2
	lda	_ppu_vram_addr
	sta	PPU_VRAM_ADDR2
@Loop:	
	lda	(_ppu_stream_addr),y
	sta	PPU_VRAM_IO
	iny
	dex
	bne	@Loop
	stx	_ppu_stream_flag		;flag clear

	;---------------
	;PPU ]ie[upj
	;c or  ֈꊇœ]܂B
	;AAvbl Ԃɓ]łTCYB
	;i8biťJオ͖Bj
PPU_Steram_a:
	lda	_ppu_stream_flag_a
	beq	PPU_Sprite

	asl	a		;
	adc	#0		;Cy <- A bit 7
	lsr	a		;A  <- A AND 0x7F
	ldy	#$0
	bcc	@V
	;cVRAMXV(8byte)
	;ie[uȂ̂ŁAʃAhX̌Jオ͖nYj
@H:	sta	_ppu_stream_flag_a
	ldx	_ppu_vram_addr_a + 1
@H_L:	lda	_ppu_vram_addr_a
	stx	PPU_VRAM_ADDR2
	sta	PPU_VRAM_ADDR2
	clc
	adc	#8
	sta	_ppu_vram_addr_a
	lda	(_ppu_stream_addr_a),y
	sta	PPU_VRAM_IO
	iny
	dec	_ppu_stream_flag_a
	bne	@H_L
	beq	PPU_Sprite

	;VRAMXV(1Byte)
@V:	tax
	lda	_ppu_ctrl
	and	#%11111011
	sta	PPU_CTRL1
	lda	_ppu_vram_addr_a + 1
	sta	PPU_VRAM_ADDR2
	lda	_ppu_vram_addr_a
	sta	PPU_VRAM_ADDR2
@V_L:	lda	(_ppu_stream_addr_a),y
	sta	PPU_VRAM_IO
	iny
	dex
	bne	@V_L
	stx	_ppu_stream_flag_a
;	beq	PPU_Sprite

	;---------------
	;Sprite DMA Process
	;SXvCgɐݒ肵܂B
PPU_Sprite:
	lda	_ppu_sprite_flag		;Use sprite DMA?
	beq	PPU_END

	lda	#0
	sta	PPU_SPR_ADDR
	lda	#>(_ppu_sprite_buff)
	sta	APU_SPR_DMA
;	lda	#0
;	sta	_ppu_sprite_flag		;flag clear

	;---------------
	; PPU setting
PPU_END:
	lda	ptb_Scroll
	bne	@s
	lda	#$20
	bne	@l
@s:	lda	#$24
@l:	sta	PPU_VRAM_ADDR2
	lda	#$00
	sta	PPU_VRAM_ADDR2		; reset video counter

;	lda	_ppu_scroll_x		; reset scrolling
	lda	ptx_Scroll + 1
	sta	PPU_VRAM_ADDR1
;	lda	_ppu_scroll_y
	lda	#0
	sta	PPU_VRAM_ADDR1

;---------------------------------------
; Call sound driver main routine
;---------------------------------------
	jsr	_nsd_main

;---------------------------------------
; Read joystick
;---------------------------------------
Key:	ldx	#1
	stx	APU_PAD1
	stx	APU_PAD2
	dex
	stx	APU_PAD1
	stx	APU_PAD2

	ldx	#8
@Loop:	lda	APU_PAD1
	ror	a
	rol	pad
	lda	APU_PAD2
	ror	a
	rol	pad + 1
	dex
	bne	@Loop

;---------------------------------------
;íANMI҂A̎ƂĎgBj
;---------------------------------------
	inc	_nmi_count

;---------------------------------------
;register pop
;---------------------------------------
	pla
	tax
	pla
	tay
	pla

	rti
.endproc
